package list

import (
	"github.com/spf13/cobra"

	eiaapi "gitea.libretechconsulting.com/50W/eia-api-go/api"
	"gitea.libretechconsulting.com/50W/eia-api-go/cmd/eia-client/internal/util"
)

var ListCmd = &cobra.Command{
	Use:    "list <name>",
	Args:   cobra.RangeArgs(0, 1),
	Short:  "List Available EIA Series",
	PreRun: util.SetClient,
	Run:    runListCmd,
}

func runListCmd(cmd *cobra.Command, _ []string) {
	logger := util.Logger(cmd)

	client, err := util.Client(cmd)
	if err != nil {
		logger.Fatal().Err(err).Send()
	}

	ctx, cncl := util.RequestCtx(cmd)
	defer cncl()
	resp, err := client.GetV2AeoRoute1DataWithResponse(ctx, "2023", &eiaapi.GetV2AeoRoute1DataParams{})
	if err != nil {
		logger.Error().Bytes("body", resp.Body)
		logger.Fatal().Err(err).Send()
	}

	logger.Info().Str("resp", string(resp.Body)).Send()
}
